
package net.mcreator.serverlist.client.gui;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.EditBox;
import net.minecraft.client.gui.components.Button;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.serverlist.world.inventory.Page1Menu;
import net.mcreator.serverlist.network.Page1ButtonMessage;
import net.mcreator.serverlist.ServerListMod;

import net.fabricmc.fabric.api.client.networking.v1.ClientPlayNetworking;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class Page1Screen extends AbstractContainerScreen<Page1Menu> {
	private final static HashMap<String, Object> guistate = Page1Menu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	EditBox hypixel;
	EditBox cubecraft;
	EditBox mineplex;
	Button button_2;
	Button button_3;
	Button button_4;

	public Page1Screen(Page1Menu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 166;
	}

	private static final ResourceLocation texture = new ResourceLocation("server_list:textures/screens/page_1.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		hypixel.render(guiGraphics, mouseX, mouseY, partialTicks);
		cubecraft.render(guiGraphics, mouseX, mouseY, partialTicks);
		mineplex.render(guiGraphics, mouseX, mouseY, partialTicks);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		if (hypixel.isFocused())
			return hypixel.keyPressed(key, b, c);
		if (cubecraft.isFocused())
			return cubecraft.keyPressed(key, b, c);
		if (mineplex.isFocused())
			return mineplex.keyPressed(key, b, c);
		return super.keyPressed(key, b, c);
	}

	@Override
	public void containerTick() {
		super.containerTick();
		hypixel.tick();
		cubecraft.tick();
		mineplex.tick();
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(font, Component.translatable("gui.server_list.page_1.label_hypixel"), 10, 25, -12829636);
		guiGraphics.drawString(font, Component.translatable("gui.server_list.page_1.label_minigames"), 10, 7, -12829636);
		guiGraphics.drawString(font, Component.translatable("gui.server_list.page_1.label_cubecraft"), 10, 61, -12829636);
		guiGraphics.drawString(font, Component.translatable("gui.server_list.page_1.label_mineplex"), 10, 97, -12829636);
	}

	@Override
	public void onClose() {
		super.onClose();
	}

	@Override
	public void init() {
		super.init();
		hypixel = new EditBox(this.font, this.leftPos + 10, this.topPos + 34, 120, 20, Component.translatable("gui.server_list.page_1.hypixel")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_1.hypixel").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.hypixel").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.hypixel").getString());
				else
					setSuggestion(null);
			}
		};
		hypixel.setMaxLength(32767);
		guistate.put("text:hypixel", hypixel);
		this.addWidget(this.hypixel);
		cubecraft = new EditBox(this.font, this.leftPos + 10, this.topPos + 70, 120, 20, Component.translatable("gui.server_list.page_1.cubecraft")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_1.cubecraft").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.cubecraft").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.cubecraft").getString());
				else
					setSuggestion(null);
			}
		};
		cubecraft.setMaxLength(32767);
		guistate.put("text:cubecraft", cubecraft);
		this.addWidget(this.cubecraft);
		mineplex = new EditBox(this.font, this.leftPos + 10, this.topPos + 106, 120, 20, Component.translatable("gui.server_list.page_1.mineplex")) {
			{
				setSuggestion(Component.translatable("gui.server_list.page_1.mineplex").getString());
			}

			@Override
			public void insertText(String text) {
				super.insertText(text);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.mineplex").getString());
				else
					setSuggestion(null);
			}

			@Override
			public void moveCursorTo(int pos) {
				super.moveCursorTo(pos);
				if (getValue().isEmpty())
					setSuggestion(Component.translatable("gui.server_list.page_1.mineplex").getString());
				else
					setSuggestion(null);
			}
		};
		mineplex.setMaxLength(32767);
		guistate.put("text:mineplex", mineplex);
		this.addWidget(this.mineplex);
		button_2 = new Button.Builder(Component.translatable("gui.server_list.page_1.button_2"), e -> {
			if (true) {
				ClientPlayNetworking.send(new ResourceLocation(ServerListMod.MODID, "page1_button_0"), new Page1ButtonMessage(0, x, y, z));
			}
		}).bounds(this.leftPos + 40, this.topPos + -20, 30, 20).build();
		guistate.put("button:button_2", button_2);
		this.addRenderableWidget(button_2);
		button_3 = new Button.Builder(Component.translatable("gui.server_list.page_1.button_3"), e -> {
			if (true) {
				ClientPlayNetworking.send(new ResourceLocation(ServerListMod.MODID, "page1_button_1"), new Page1ButtonMessage(1, x, y, z));
			}
		}).bounds(this.leftPos + 70, this.topPos + -20, 30, 20).build();
		guistate.put("button:button_3", button_3);
		this.addRenderableWidget(button_3);
		button_4 = new Button.Builder(Component.translatable("gui.server_list.page_1.button_4"), e -> {
			if (true) {
				ClientPlayNetworking.send(new ResourceLocation(ServerListMod.MODID, "page1_button_2"), new Page1ButtonMessage(2, x, y, z));
			}
		}).bounds(this.leftPos + 100, this.topPos + -20, 30, 20).build();
		guistate.put("button:button_4", button_4);
		this.addRenderableWidget(button_4);
	}
}
